﻿using System;

namespace Dekorator
{
    using UMK.WzorceStrukturalne;

    class Program
    {
        private static void wyświetlInformacjeONapoju(INapój napój)
        {
            Console.WriteLine(napój.ToString() + " za " + napój.Cena() + " zł");
        }

        static void Main(string[] args)
        {
            INapój kawa = new Kawa();
            wyświetlInformacjeONapoju(kawa);

            INapój napój1 = new NapójZeSzczyptąCynamonu(kawa);
            wyświetlInformacjeONapoju(napój1);

            INapój napój2 = new NapójZeSzczyptąCynamonu(napój1);
            wyświetlInformacjeONapoju(napój2);

            INapój napój3 = new NapójZCukrem(napój2, 2);
            wyświetlInformacjeONapoju(napój3);

            INapój napój4 = new NapójZCukrem(new NapójZeSzczyptąCynamonu(new NapójZeSzczyptąCynamonu(new Kawa())), 2);
            wyświetlInformacjeONapoju(napój4);

            INapój herbataZimowa = new Herbata();
            if (true) herbataZimowa = new NapójZCukrem(herbataZimowa, 2);
            herbataZimowa = new NapójZeSzczyptąCynamonu(herbataZimowa);
            herbataZimowa = new NapójZPlastremCytryny(herbataZimowa);
            wyświetlInformacjeONapoju(herbataZimowa);
        }
    }
}
